<?php

/**
 * @file
 * Contains CFSubjectInterface.php.
 */

namespace Drupal\changed_fields;

/**
 * Interface CFSubjectInterface.
 */
interface CFSubjectInterface {

  /**
   * Add observer to list.
   *
   * @param CFObserverInterface $observer
   */
  public function addObserver(CFObserverInterface $observer);

  /**
   * Remove observer from list.
   *
   * @param CFObserverInterface $observer
   */
  public function removeObserver(CFObserverInterface $observer);

  /**
   *  Notify all registered observers if needed.
   */
  public function checkNodeFields();

  /**
   * Returns node object.
   */
  public function getNode();

  /**
   * Returns changed fields.
   */
  public function getChangedFields();

}
